// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Barcodesuite.pas' rev: 20.00

#ifndef BarcodesuiteHPP
#define BarcodesuiteHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Barcodesuite
{
//-- type declarations -------------------------------------------------------
typedef System::UnicodeString WString;

#pragma option push -b-
enum TBinarizer { biLocalAverage, biGlobalHistogram, biFixedThreshold, biCast };
#pragma option pop

#pragma option push -b-
enum TCharacterSet { csUnknown, csAscii, csIso8859_1, csIso8859_2, csIso8859_3, csIso8859_4, csIso8859_5, csIso8859_6, csIso8859_7, csIso8859_8, csIso8859_9, csIso8859_10, csIso8859_11, csIso8859_13, csIso8859_14, csIso8859_15, csIso8859_16, csCp437, csCp1250, csCp1251, csCp1252, csCp1256, csShiftJis, csBig5, csGb2312, csGb18030, csEucJp, csEucKr, csUnicodeBig, csUtf8, csBinary };
#pragma option pop

#pragma option push -b-
enum TContentType { ctText, ctBinary, ctMixed, ctGS1, ctISO15434, ctUnknownECI };
#pragma option pop

#pragma option push -b-
enum TEanAddOn { eqIgnore, eaRead, eaRequire };
#pragma option pop

#pragma option push -b-
enum TEccLevel { ecUnused, ec0, ec1, ec2, ec3, ec4, ec5, ec6, ec7, ec8 };
#pragma option pop

#pragma option push -b-
enum TErrorType { etNone, etFormat, etChecksum, etUnsupported };
#pragma option pop

#pragma option push -b-
enum TFormat { foUnknown, foAztec, foCodabar, foCode39, foCode93, foCode128, foDataBar, foDataBarExpanded, foDataMatrix, foEan8, foEan13, foItf, foMaxiCode, foPdf417, foQrCode, foUpcA, foUpcE, foMicroQrCode, foRMicroQrCode, foDxFilmEdge };
#pragma option pop

typedef Set<TFormat, foUnknown, foDxFilmEdge>  TFormats;

#pragma option push -b-
enum TTextMode { tmPlain, tmECI, tmHumanReadable, tmHex, tmEscaped };
#pragma option pop

struct TDecodeResult
{
	
public:
	TErrorType ErrorType;
	System::AnsiString ErrorMessage;
	TFormat Format;
	System::UnicodeString FormatName;
	TByteDynArray Data;
	System::UnicodeString Text;
	System::AnsiString TextUtf8;
	System::AnsiString RenderedText;
	System::UnicodeString EccLevel;
	System::AnsiString EccLevelUtf8;
	TContentType ContentType;
	System::AnsiString Version;
	bool HasEci;
	TByteDynArray EciData;
	Types::TPoint TopLeft;
	Types::TPoint TopRight;
	Types::TPoint BottomLeft;
	Types::TPoint BottomRight;
	int LineCount;
	int Orientation;
	bool Inverted;
	bool Mirrored;
	System::AnsiString SymbologyIdentifier;
	int SequenceSize;
	int SequenceIndex;
	System::AnsiString SequenceId;
	bool ReaderInit;
};


typedef DynamicArray<TDecodeResult> TDecodeResults;

struct TEncodeResult
{
	
public:
	int Width;
	int Height;
	TByteDynArray Data;
	System::AnsiString ErrorMessage;
};


class DELPHICLASS EBarcodeError;
class PASCALIMPLEMENTATION EBarcodeError : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EBarcodeError(const System::UnicodeString Msg) : Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EBarcodeError(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ inline __fastcall EBarcodeError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ inline __fastcall EBarcodeError(int Ident, System::TVarRec const *Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ inline __fastcall EBarcodeError(const System::UnicodeString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EBarcodeError(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EBarcodeError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EBarcodeError(System::PResStringRec ResStringRec, System::TVarRec const *Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EBarcodeError(void) { }
	
};


class DELPHICLASS TBarcodeDecoder;
class PASCALIMPLEMENTATION TBarcodeDecoder : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TBinarizer FBinarizer;
	System::UnicodeString FCharacterSet;
	TEanAddOn FEanAddOn;
	TFormats FFormats;
	System::Byte FMaxBarcodeCount;
	int FMinLineCount;
	bool FPureBarcode;
	bool FReturnCodabarStartEnd;
	bool FReturnErrors;
	TTextMode FTextMode;
	bool FTryCode39ExtendedMode;
	bool FTryDownscale;
	bool FTryHarder;
	bool FTryRotate;
	bool FTryInvert;
	bool FValidateCode39;
	bool FValidateITF;
	
public:
	__fastcall TBarcodeDecoder(void);
	TDecodeResults __fastcall Decode(Graphics::TGraphic* Graphic)/* overload */;
	TDecodeResults __fastcall Decode(Graphics::TGraphic* Graphic, const Types::TRect &Rect)/* overload */;
	__property TBinarizer Binarizer = {read=FBinarizer, write=FBinarizer, nodefault};
	__property System::UnicodeString CharacterSet = {read=FCharacterSet, write=FCharacterSet};
	__property TEanAddOn EanAddOn = {read=FEanAddOn, write=FEanAddOn, nodefault};
	__property TFormats Formats = {read=FFormats, write=FFormats, nodefault};
	__property System::Byte MaxBarcodeCount = {read=FMaxBarcodeCount, write=FMaxBarcodeCount, nodefault};
	__property int MinLineCount = {read=FMinLineCount, write=FMinLineCount, nodefault};
	__property bool PureBarcode = {read=FPureBarcode, write=FPureBarcode, nodefault};
	__property bool ReturnCodabarStartEnd = {read=FReturnCodabarStartEnd, write=FReturnCodabarStartEnd, nodefault};
	__property bool ReturnErrors = {read=FReturnErrors, write=FReturnErrors, nodefault};
	__property TTextMode TextMode = {read=FTextMode, write=FTextMode, nodefault};
	__property bool TryCode39ExtendedMode = {read=FTryCode39ExtendedMode, write=FTryCode39ExtendedMode, nodefault};
	__property bool TryDownscale = {read=FTryDownscale, write=FTryDownscale, nodefault};
	__property bool TryHarder = {read=FTryHarder, write=FTryHarder, nodefault};
	__property bool TryInvert = {read=FTryInvert, write=FTryInvert, nodefault};
	__property bool TryRotate = {read=FTryRotate, write=FTryRotate, nodefault};
	__property bool ValidateCode39 = {read=FValidateCode39, write=FValidateCode39, nodefault};
	__property bool ValidateITF = {read=FValidateITF, write=FValidateITF, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TBarcodeDecoder(void) { }
	
};


class DELPHICLASS TBarcodeEncoder;
class PASCALIMPLEMENTATION TBarcodeEncoder : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Graphics::TColor FBackColor;
	TCharacterSet FCharacterSet;
	TEccLevel FEccLevel;
	Graphics::TColor FForeColor;
	TFormat FFormat;
	int FMargin;
	System::UnicodeString FText;
	int FWidth;
	int FHeight;
	
public:
	__fastcall TBarcodeEncoder(void);
	TEncodeResult __fastcall Encode(Graphics::TBitmap* Bitmap);
	__property Graphics::TColor BackColor = {read=FBackColor, write=FBackColor, nodefault};
	__property TCharacterSet CharacterSet = {read=FCharacterSet, write=FCharacterSet, nodefault};
	__property TEccLevel EccLevel = {read=FEccLevel, write=FEccLevel, nodefault};
	__property Graphics::TColor ForeColor = {read=FForeColor, write=FForeColor, nodefault};
	__property TFormat Format = {read=FFormat, write=FFormat, nodefault};
	__property int Height = {read=FHeight, write=FHeight, nodefault};
	__property int Margin = {read=FMargin, write=FMargin, nodefault};
	__property System::UnicodeString Text = {read=FText, write=FText};
	__property int Width = {read=FWidth, write=FWidth, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TBarcodeEncoder(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::UnicodeString ZXingLibraryName;
extern PACKAGE unsigned ZXingLibrary;
extern PACKAGE bool __fastcall LoadedLibrary(void);
extern PACKAGE void __fastcall UnloadLibrary(void);
extern PACKAGE void __fastcall LoadLibrary(void);

}	/* namespace Barcodesuite */
using namespace Barcodesuite;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// BarcodesuiteHPP
