// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'BarcodeSuite.pas' rev: 6.00

#ifndef BarcodeSuiteHPP
#define BarcodeSuiteHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Graphics.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Barcodesuite
{
//-- type declarations -------------------------------------------------------
typedef WideString WString;

#pragma option push -b-
enum TBinarizer { biLocalAverage, biGlobalHistogram, biFixedThreshold, biCast };
#pragma option pop

#pragma option push -b-
enum TCharacterSet { csUnknown, csAscii, csIso8859_1, csIso8859_2, csIso8859_3, csIso8859_4, csIso8859_5, csIso8859_6, csIso8859_7, csIso8859_8, csIso8859_9, csIso8859_10, csIso8859_11, csIso8859_13, csIso8859_14, csIso8859_15, csIso8859_16, csCp437, csCp1250, csCp1251, csCp1252, csCp1256, csShiftJis, csBig5, csGb2312, csGb18030, csEucJp, csEucKr, csUnicodeBig, csUtf8, csBinary };
#pragma option pop

#pragma option push -b-
enum TContentType { ctText, ctBinary, ctMixed, ctGS1, ctISO15434, ctUnknownECI };
#pragma option pop

#pragma option push -b-
enum TEanAddOn { eqIgnore, eaRead, eaRequire };
#pragma option pop

#pragma option push -b-
enum TEccLevel { ecUnused, ec0, ec1, ec2, ec3, ec4, ec5, ec6, ec7, ec8 };
#pragma option pop

#pragma option push -b-
enum TErrorType { etNone, etFormat, etChecksum, etUnsupported };
#pragma option pop

#pragma option push -b-
enum TFormat { foUnknown, foAztec, foCodabar, foCode39, foCode93, foCode128, foDataBar, foDataBarExpanded, foDataMatrix, foEan8, foEan13, foItf, foMaxiCode, foPdf417, foQrCode, foUpcA, foUpcE, foMicroQrCode, foRMicroQrCode, foDxFilmEdge };
#pragma option pop

typedef Set<TFormat, foUnknown, foDxFilmEdge>  TFormats;

#pragma option push -b-
enum TTextMode { tmPlain, tmECI, tmHumanReadable, tmHex, tmEscaped };
#pragma option pop

#pragma pack(push, 4)
struct TDecodeResult
{
	TErrorType ErrorType;
	AnsiString ErrorMessage;
	TFormat Format;
	AnsiString FormatName;
	DynamicArray<Byte >  Data;
	WideString Text;
	AnsiString TextUtf8;
	AnsiString RenderedText;
	WideString EccLevel;
	AnsiString EccLevelUtf8;
	TContentType ContentType;
	AnsiString Version;
	bool HasEci;
	DynamicArray<Byte >  EciData;
	Types::TPoint TopLeft;
	Types::TPoint TopRight;
	Types::TPoint BottomLeft;
	Types::TPoint BottomRight;
	int LineCount;
	int Orientation;
	bool Inverted;
	bool Mirrored;
	AnsiString SymbologyIdentifier;
	int SequenceSize;
	int SequenceIndex;
	AnsiString SequenceId;
	bool ReaderInit;
} ;
#pragma pack(pop)

typedef DynamicArray<TDecodeResult >  TDecodeResults;

#pragma pack(push, 4)
struct TEncodeResult
{
	int Width;
	int Height;
	DynamicArray<Byte >  Data;
	AnsiString ErrorMessage;
} ;
#pragma pack(pop)

class DELPHICLASS EBarcodeError;
class PASCALIMPLEMENTATION EBarcodeError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EBarcodeError(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EBarcodeError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EBarcodeError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EBarcodeError(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EBarcodeError(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EBarcodeError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EBarcodeError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EBarcodeError(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EBarcodeError(void) { }
	#pragma option pop
	
};


class DELPHICLASS TBarcodeDecoder;
class PASCALIMPLEMENTATION TBarcodeDecoder : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TBinarizer FBinarizer;
	AnsiString FCharacterSet;
	TEanAddOn FEanAddOn;
	TFormats FFormats;
	Byte FMaxBarcodeCount;
	int FMinLineCount;
	bool FPureBarcode;
	bool FReturnCodabarStartEnd;
	bool FReturnErrors;
	TTextMode FTextMode;
	bool FTryCode39ExtendedMode;
	bool FTryDownscale;
	bool FTryHarder;
	bool FTryRotate;
	bool FTryInvert;
	bool FValidateCode39;
	bool FValidateITF;
	
public:
	__fastcall TBarcodeDecoder(void);
	TDecodeResults __fastcall Decode(Graphics::TGraphic* Graphic)/* overload */;
	TDecodeResults __fastcall Decode(Graphics::TGraphic* Graphic, const Types::TRect &Rect)/* overload */;
	__property TBinarizer Binarizer = {read=FBinarizer, write=FBinarizer, nodefault};
	__property AnsiString CharacterSet = {read=FCharacterSet, write=FCharacterSet};
	__property TEanAddOn EanAddOn = {read=FEanAddOn, write=FEanAddOn, nodefault};
	__property TFormats Formats = {read=FFormats, write=FFormats, nodefault};
	__property Byte MaxBarcodeCount = {read=FMaxBarcodeCount, write=FMaxBarcodeCount, nodefault};
	__property int MinLineCount = {read=FMinLineCount, write=FMinLineCount, nodefault};
	__property bool PureBarcode = {read=FPureBarcode, write=FPureBarcode, nodefault};
	__property bool ReturnCodabarStartEnd = {read=FReturnCodabarStartEnd, write=FReturnCodabarStartEnd, nodefault};
	__property bool ReturnErrors = {read=FReturnErrors, write=FReturnErrors, nodefault};
	__property TTextMode TextMode = {read=FTextMode, write=FTextMode, nodefault};
	__property bool TryCode39ExtendedMode = {read=FTryCode39ExtendedMode, write=FTryCode39ExtendedMode, nodefault};
	__property bool TryDownscale = {read=FTryDownscale, write=FTryDownscale, nodefault};
	__property bool TryHarder = {read=FTryHarder, write=FTryHarder, nodefault};
	__property bool TryInvert = {read=FTryInvert, write=FTryInvert, nodefault};
	__property bool TryRotate = {read=FTryRotate, write=FTryRotate, nodefault};
	__property bool ValidateCode39 = {read=FValidateCode39, write=FValidateCode39, nodefault};
	__property bool ValidateITF = {read=FValidateITF, write=FValidateITF, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TBarcodeDecoder(void) { }
	#pragma option pop
	
};


class DELPHICLASS TBarcodeEncoder;
class PASCALIMPLEMENTATION TBarcodeEncoder : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Graphics::TColor FBackColor;
	TCharacterSet FCharacterSet;
	TEccLevel FEccLevel;
	Graphics::TColor FForeColor;
	TFormat FFormat;
	int FMargin;
	WideString FText;
	int FWidth;
	int FHeight;
	
public:
	__fastcall TBarcodeEncoder(void);
	TEncodeResult __fastcall Encode(Graphics::TBitmap* Bitmap);
	__property Graphics::TColor BackColor = {read=FBackColor, write=FBackColor, nodefault};
	__property TCharacterSet CharacterSet = {read=FCharacterSet, write=FCharacterSet, nodefault};
	__property TEccLevel EccLevel = {read=FEccLevel, write=FEccLevel, nodefault};
	__property Graphics::TColor ForeColor = {read=FForeColor, write=FForeColor, nodefault};
	__property TFormat Format = {read=FFormat, write=FFormat, nodefault};
	__property int Height = {read=FHeight, write=FHeight, nodefault};
	__property int Margin = {read=FMargin, write=FMargin, nodefault};
	__property WideString Text = {read=FText, write=FText};
	__property int Width = {read=FWidth, write=FWidth, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TBarcodeEncoder(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
#pragma error Unsupported symbol type (23, BarcodeSuite)
extern PACKAGE AnsiString ZXingLibraryName;
extern PACKAGE unsigned ZXingLibrary;
extern PACKAGE bool __fastcall LoadedLibrary(void);
extern PACKAGE void __fastcall UnloadLibrary(void);
extern PACKAGE void __fastcall LoadLibrary(void);

}	/* namespace Barcodesuite */
using namespace Barcodesuite;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// BarcodeSuite
