//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ExtDlgs.hpp>
#include "BarcodeSuite.hpp"
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
    TOpenPictureDialog *OpenPictureDialog;
    TPanel *PanelLeft;
    TLabel *LabelBinarizer;
    TLabel *LabelEanAddOn;
    TLabel *LabelMinLineCount;
    TLabel *LabelMaxBarcodes;
    TLabel *LabelTextMode;
    TButton *ButtonSelectPicture;
    TCheckBox *CheckBoxAztec;
    TCheckBox *CheckBoxCodabar;
    TCheckBox *CheckBoxCode39;
    TCheckBox *CheckBoxCode93;
    TCheckBox *CheckBoxCode128;
    TCheckBox *CheckBoxDataBar;
    TCheckBox *CheckBoxDataBarExpanded;
    TCheckBox *CheckBoxDataMatrix;
    TCheckBox *CheckBoxEan8;
    TCheckBox *CheckBoxEan13;
    TCheckBox *CheckBoxItf;
    TCheckBox *CheckBoxMaxiCode;
    TCheckBox *CheckBoxPdf417;
    TCheckBox *CheckBoxQrCode;
    TCheckBox *CheckBoxUpcA;
    TCheckBox *CheckBoxUpcE;
    TCheckBox *CheckBoxMicroQrCode;
    TComboBox *ComboBoxBinarizer;
    TComboBox *ComboBoxEanAddOn;
    TCheckBox *CheckBoxTryHarder;
    TCheckBox *CheckBoxTryRotate;
    TCheckBox *CheckBoxTryDownscale;
    TCheckBox *CheckBoxPureBarcode;
    TCheckBox *CheckBoxShowPosition;
    TCheckBox *CheckBoxCodaBarStartEnd;
    TCheckBox *CheckBoxValidateItf;
    TCheckBox *CheckBoxValidateCode39;
    TCheckBox *CheckBoxCode39Extended;
    TEdit *EditMinLineCount;
    TUpDown *UpDownMinLineCount;
    TEdit *EditMaxBarcodes;
    TUpDown *UpDownMaxBarcodes;
    TCheckBox *CheckBoxTryInvert;
    TComboBox *ComboBoxTextMode;
    TCheckBox *CheckBoxDxFilmEdge;
    TCheckBox *CheckBoxRMicroQrCode;
    TPanel *PanelRight;
    TSplitter *Splitter;
    TImage *Image;
    TPaintBox *PaintBox;
    TMemo *Memo;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ButtonSelectPictureClick(TObject *Sender);
    void __fastcall CheckBoxAztecClick(TObject *Sender);
    void __fastcall CheckBoxCodabarClick(TObject *Sender);
    void __fastcall CheckBoxCode93Click(TObject *Sender);
    void __fastcall CheckBoxCode39Click(TObject *Sender);
    void __fastcall CheckBoxCode128Click(TObject *Sender);
    void __fastcall CheckBoxDataBarClick(TObject *Sender);
    void __fastcall CheckBoxDataBarExpandedClick(TObject *Sender);
    void __fastcall CheckBoxDataMatrixClick(TObject *Sender);
    void __fastcall CheckBoxEan8Click(TObject *Sender);
    void __fastcall CheckBoxEan13Click(TObject *Sender);
    void __fastcall CheckBoxItfClick(TObject *Sender);
    void __fastcall CheckBoxMaxiCodeClick(TObject *Sender);
    void __fastcall CheckBoxPdf417Click(TObject *Sender);
    void __fastcall CheckBoxQrCodeClick(TObject *Sender);
    void __fastcall CheckBoxUpcAClick(TObject *Sender);
    void __fastcall CheckBoxUpcEClick(TObject *Sender);
    void __fastcall CheckBoxMicroQrCodeClick(TObject *Sender);
    void __fastcall CheckBoxShowPositionClick(TObject *Sender);
    void __fastcall ComboBoxBinarizerChange(TObject *Sender);
    void __fastcall ComboBoxEanAddOnChange(TObject *Sender);
    void __fastcall EditMinLineCountChange(TObject *Sender);
    void __fastcall EditMaxBarcodesChange(TObject *Sender);
    void __fastcall CheckBoxTryHarderClick(TObject *Sender);
    void __fastcall CheckBoxTryRotateClick(TObject *Sender);
    void __fastcall CheckBoxTryDownscaleClick(TObject *Sender);
    void __fastcall CheckBoxPureBarcodeClick(TObject *Sender);
    void __fastcall CheckBoxCodaBarStartEndClick(TObject *Sender);
    void __fastcall CheckBoxValidateItfClick(TObject *Sender);
    void __fastcall CheckBoxValidateCode39Click(TObject *Sender);
    void __fastcall CheckBoxCode39ExtendedClick(TObject *Sender);
    void __fastcall PaintBoxPaint(TObject *Sender);
  void __fastcall ComboBoxTextModeChange(TObject *Sender);
  void __fastcall CheckBoxTryInvertClick(TObject *Sender);
    void __fastcall CheckBoxRMicroQrCodeClick(TObject *Sender);
    void __fastcall CheckBoxDxFilmEdgeClick(TObject *Sender);
private:	// User declarations
    TBarcodeDecoder *BarcodeDecoder;
    TPoint TopLeft;
    TPoint TopRight;
    TPoint BottomLeft;
    TPoint BottomRight;
    void __fastcall AddLine(const String Text = "");
    void __fastcall DecodeBarcode();
public:		// User declarations
    __fastcall TFormMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
