//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.XPMan.hpp>
#include "MediaSuite.hpp"
#include "BarcodeSuite.hpp"
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:  // IDE-managed Components
    TLabel *LabelBarcode;
    TPanel *PanelPreview;
    TPanel *PanelRight;
    TLabel *LabelBacklightCompensation;
    TLabel *LabelBrightness;
    TLabel *LabelColorEnable;
    TLabel *LabelContrast;
    TLabel *LabelExposure;
    TLabel *LabelFocus;
    TLabel *LabelGain;
    TLabel *LabelGamma;
    TLabel *LabelHue;
    TLabel *LabelIris;
    TLabel *LabelPan;
    TLabel *LabelRoll;
    TLabel *LabelSaturation;
    TLabel *LabelSharpness;
    TLabel *LabelTilt;
    TLabel *LabelWhiteBalance;
    TLabel *LabelZoom;
    TTrackBar *TrackBarBacklightCompensation;
    TCheckBox *CheckBoxBacklightCompensation;
    TTrackBar *TrackBarBrightness;
    TCheckBox *CheckBoxBrightness;
    TTrackBar *TrackBarColorEnable;
    TCheckBox *CheckBoxColorEnable;
    TTrackBar *TrackBarContrast;
    TCheckBox *CheckBoxContrast;
    TTrackBar *TrackBarExposure;
    TCheckBox *CheckBoxExposure;
    TTrackBar *TrackBarFocus;
    TCheckBox *CheckBoxFocus;
    TTrackBar *TrackBarGain;
    TCheckBox *CheckBoxGain;
    TTrackBar *TrackBarGamma;
    TCheckBox *CheckBoxGamma;
    TTrackBar *TrackBarHue;
    TCheckBox *CheckBoxHue;
    TTrackBar *TrackBarIris;
    TCheckBox *CheckBoxIris;
    TTrackBar *TrackBarPan;
    TCheckBox *CheckBoxPan;
    TTrackBar *TrackBarRoll;
    TCheckBox *CheckBoxRoll;
    TTrackBar *TrackBarSaturation;
    TCheckBox *CheckBoxSaturation;
    TTrackBar *TrackBarSharpness;
    TCheckBox *CheckBoxSharpness;
    TTrackBar *TrackBarTilt;
    TCheckBox *CheckBoxTilt;
    TTrackBar *TrackBarWhiteBalance;
    TCheckBox *CheckBoxWhiteBalance;
    TTrackBar *TrackBarZoom;
    TCheckBox *CheckBoxZoom;
    TButton *ButtonDefaultValues;
    TPanel *PanelTop;
    TLabel *LabelCamera;
    TLabel *LabelFormat;
    TComboBox *ComboBoxCamera;
    TComboBox *ComboBoxFormat;
    TCheckBox *CheckBoxMirror;
    TComboBox *ComboBoxRotation;
    TTimer *Timer;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall ComboBoxCameraChange(TObject *Sender);
  void __fastcall ComboBoxCameraDropDown(TObject *Sender);
  void __fastcall ComboBoxFormatChange(TObject *Sender);
  void __fastcall ButtonDefaultValuesClick(TObject *Sender);
  void __fastcall TrackBarChange(TObject *Sender);
  void __fastcall CheckBoxClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
	void __fastcall CheckBoxMirrorClick(TObject *Sender);
	void __fastcall ComboBoxRotationChange(TObject *Sender);
    void __fastcall TimerTimer(TObject *Sender);
private:  // User declarations
  TIActivateDynArray Devices;
  _di_ICaptureEngine CaptureEngine;
  TMediaTypes PreviewMediaTypes;
  TBarcodeDecoder *BarcodeDecoder;
  TBitmap *Bitmap;
  TStream *BitmapStream;
  void __fastcall ClearTrackBars();
  void __fastcall SetTrackBars();
  void __fastcall CaptureEnginePhotoStateChanged(TObject *Sender);
  void __fastcall CaptureEnginePreviewStateChanged(TObject *Sender);
  void __fastcall CaptureEngineStateChanged(TObject *Sender);
  void __fastcall UpdateControls();
public:    // User declarations
  __fastcall TFormMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
