//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  BarcodeEncoder = new TBarcodeEncoder();
  BarcodeEncoder->Text = MemoText->Text;
  BarcodeEncoder->Height = UpDownHeight->Position;
  BarcodeEncoder->Width = UpDownWidth->Position;

  Bitmap = new TBitmap();
  Bitmap->PixelFormat = pf24bit;

  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormDestroy(TObject *Sender)
{
  delete Bitmap;
  delete BarcodeEncoder;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ComboBoxFormatChange(TObject *Sender)
{
  BarcodeEncoder->Format = (TFormat)(ComboBoxFormat->ItemIndex + 1);
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ColorBoxBackColorChange(TObject *Sender)
{
  BarcodeEncoder->BackColor = ColorBoxBackColor->Selected;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ColorBoxForeColorChange(TObject *Sender)
{
  BarcodeEncoder->ForeColor = ColorBoxForeColor->Selected;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ComboBoxPixelFormatChange(TObject *Sender)
{
  Bitmap->PixelFormat = pfDevice; // reset bitmap
  switch (ComboBoxPixelFormat->ItemIndex)
  {
    case 0:
      Bitmap->PixelFormat = pf1bit;
      break;

    case 1:
      Bitmap->PixelFormat = pf24bit;
      break;

    case 2:
      Bitmap->PixelFormat = pf32bit;
      break;
  }
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ComboBoxCharacterSetChange(TObject *Sender)
{
  BarcodeEncoder->CharacterSet = (TCharacterSet)ComboBoxCharacterSet->ItemIndex;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ComboBoxEccLevelChange(TObject *Sender)
{
  BarcodeEncoder->EccLevel = (TEccLevel)ComboBoxEccLevel->ItemIndex;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::EditMarginChange(TObject *Sender)
{
  BarcodeEncoder->Margin = UpDownMargin->Position;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::EditHeightChange(TObject *Sender)
{
  BarcodeEncoder->Height = UpDownHeight->Position;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::EditWidthChange(TObject *Sender)
{
  BarcodeEncoder->Width = UpDownWidth->Position;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonSaveClick(TObject *Sender)
{
  if (SavePictureDialog->Execute())
    Bitmap->SaveToFile(SavePictureDialog->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MemoTextChange(TObject *Sender)
{
  BarcodeEncoder->Text = MemoText->Text;
  DrawBarcode();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::DrawBarcode()
{
  try
  {
    TEncodeResult EncodeResult = BarcodeEncoder->Encode(Bitmap);
    Image->Picture->Assign(Bitmap);
    StatusBar->SimpleText = EncodeResult.ErrorMessage;
  }
  catch (Exception &exception)
  {
    StatusBar->SimpleText = exception.Message;
  }
}
//---------------------------------------------------------------------------
