//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ExtDlgs.hpp>
#include "BarcodeSuite.hpp"
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
    TPanel *PanelTop;
    TImage *Image;
    TPanel *PanelBottom;
    TLabel *LabelFormat;
    TLabel *LabelBackColor;
    TLabel *LabelForeColor;
    TLabel *LabelPixelFormat;
    TLabel *LabelEccLevel;
    TLabel *LabelMargin;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TComboBox *ComboBoxFormat;
    TMemo *MemoText;
    TColorBox *ColorBoxBackColor;
    TColorBox *ColorBoxForeColor;
    TComboBox *ComboBoxPixelFormat;
    TButton *ButtonSave;
    TComboBox *ComboBoxEccLevel;
    TEdit *EditMargin;
    TUpDown *UpDownMargin;
    TEdit *EditHeight;
    TUpDown *UpDownHeight;
    TEdit *EditWidth;
    TUpDown *UpDownWidth;
    TComboBox *ComboBoxCharacterSet;
    TStatusBar *StatusBar;
    TSavePictureDialog *SavePictureDialog;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ComboBoxFormatChange(TObject *Sender);
    void __fastcall ColorBoxBackColorChange(TObject *Sender);
    void __fastcall ColorBoxForeColorChange(TObject *Sender);
    void __fastcall ComboBoxPixelFormatChange(TObject *Sender);
    void __fastcall ComboBoxCharacterSetChange(TObject *Sender);
    void __fastcall ComboBoxEccLevelChange(TObject *Sender);
    void __fastcall EditMarginChange(TObject *Sender);
    void __fastcall EditHeightChange(TObject *Sender);
    void __fastcall EditWidthChange(TObject *Sender);
    void __fastcall ButtonSaveClick(TObject *Sender);
    void __fastcall MemoTextChange(TObject *Sender);
private:	// User declarations
    TBarcodeEncoder *BarcodeEncoder;
    TBitmap *Bitmap;
    void __fastcall DrawBarcode();
public:		// User declarations
    __fastcall TFormMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
